/* fichero norma.c */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void main(void) {       /* funcion o programa principal */
    int i, j, m, n;
    double **a;
    double **maAlloc(int m, int n);
    double normaInf(int m, int n, double **a);
    printf("Teclea m y n: ");
    scanf("%d%d", &m, &n);
    a=maAlloc(m, n);
    printf("\nTeclea los elementos de la matriz por filas\n");
    for(i=0; i<m; i++)
        for(j=0; j<n; j++)
            scanf(" %lf", &a[i][j]);
    printf("\nLa norma sub-infinito es: %lf\n", normaInf(m, n, a));
}

double **maAlloc(int m, int n) {
    double **matrix;
    int i;
    matrix=calloc(m, sizeof(double *));
    matrix[0]=calloc(m*n, sizeof(double));
    for (i=1; i<m; i++)
        matrix[i]=matrix[i-1] + n;
    return matrix;
}

double normaInf(int m, int n, double **a) {
    double norma=0.0, suma;
    int i, j;
    for (i=0; i<m; i++) {
        suma=0.0;
        for (j=0; j<n; j++)
            suma+=fabs(a[i][j]);
        if (norma<suma)
            norma=suma;
    }
    return norma;
}
