/* fichero antisim.c */
#include <stdio.h>
#include <malloc.h>

void main(void) {
    double **a;
    double **sim;
    double **antisim;
    int    i, j, n;

    printf("Descomposicion de una matriz cuadrada cualquiera en \n");
    printf("suma de simetrica y antisimetrica.\n");
    printf("\nIntroduce la dimension de la matriz a descomponer:\n");
    printf("Dimension: ");
    scanf("%d", &n);
    printf("Introduce los valores de la matriz:\n");
    a=malloc(n*sizeof(double*));
    sim=malloc(n*sizeof(double*));
    antisim=malloc(n*sizeof(double*));
    for (i=0; i<n; i++) {
        a[i]=malloc(n*sizeof(double));
        sim[i]=malloc(n*sizeof(double));
        antisim[i]=malloc(n*sizeof(double));
    }

    for (i=0; i<n; i++)
        for (j=0; j<n; j++) {
            printf("%d,%d: ", i+1, j+1);
            scanf("%lf", &a[i][j]);
        }

    for (i=0; i<n; i++)
        for (j=0; j<n; j++) {
            sim[i][j]=(a[i][j]+a[j][i])/2;
            antisim[i][j]=(a[i][j]-a[j][i])/2;
        }

    printf("\nLa matriz simetrica es:\n");
    for (i=0; i<n; i++) {
        for (j=0; j<n; j++)
            printf("%lf  ", sim[i][j]);
        printf("\n");
    }
    printf("\n");
    printf("La matriz antisimetrica es:\n");
    for (i=0; i<n; i++) {
        for (j=0; j<n; j++)
            printf("%lf   ", antisim[i][j]);
        printf("\n");
    }
    printf("\n");
    printf("La matriz original debe ser:\n");
    for (i=0; i<n; i++) {
        for (j=0; j<n; j++)
            printf("%lf   ", sim[i][j]+antisim[i][j] );
        printf("\n");
    }
    printf("\n");
}
